menu = {}

local Buttons = {}
function menu:load()
  menu_art = love.graphics.newImage('images/menu_art.png')
  game_font = love.graphics.newFont('fonts/Chilanka-Regular.ttf',50) -- load my font
  love.graphics.setFont(game_font) -- set my font
  mouseClickSound= love.audio.newSource("sounds/button_click.wav",'stream')
  
  Buttons.play = love.graphics.newImage('images/buttons/play_button.png')
  Buttons.exit = love.graphics.newImage('images/buttons/exit_button.png')
  Buttons.Pxs = 0.5
  Buttons.Pys = 0.5
  Buttons.Exs = 0.5
  Buttons.Eys = 0.5
  Buttons.x = 350
  Buttons.Py = 300
  Buttons.Ey = 400
end

function checkIfMouseOver(Ox,Oy,Ow,Oh) 
  if  mouse_x > Ox-(Ow/2) and
         mouse_x < Ox+(Ow/2) and
         mouse_y > Oy-(Oh/2) and
         mouse_y < Oy+ (Oh/2) then return true
  else return false end
end

function menu:update(dt)
  
  mouse_x = love.mouse.getX()
  mouse_y = love.mouse.getY()
  
  --make the buttons bigger when mouse hovers above them
  -- both code are poorly written, to be tuned later
  if checkIfMouseOver(Buttons.x,Buttons.Py,Buttons.play:getWidth()/2,Buttons.play:getHeight()/2) then
    if Buttons.Pxs <0.6 then
      Buttons.Pxs= Buttons.Pxs + 0.01
    end
  else
    if Buttons.Pxs >0.5 then
      Buttons.Pxs = Buttons.Pxs - 0.01
    end
  end
  
  if checkIfMouseOver(Buttons.x,Buttons.Ey,Buttons.exit:getWidth()/2,Buttons.exit:getHeight()/2) then
    if Buttons.Exs <0.6 then
      Buttons.Exs= Buttons.Exs + 0.01
    end
  else
    if Buttons.Exs >0.5 then
      Buttons.Exs = Buttons.Exs - 0.01
    end
  end
  -- now binding controls to the buttons
  function button_controls()
    if scene == menu then
      if checkIfMouseOver(Buttons.x,Buttons.Py,Buttons.play:getWidth()/2,Buttons.play:getHeight()/2) then
        function  love.mousepressed(mouse_x,mouse_y)
          love.audio.play(mouseClickSound)
          scene = Gameplay_scene
        end
      end
      -- for the exit button
      if checkIfMouseOver(Buttons.x,Buttons.Ey,Buttons.exit:getWidth()/2,Buttons.exit:getHeight()/2) then
        function  love.mousepressed(mouse_x,mouse_y)
          love.event.quit()
        end
      end
    end
  end
  button_controls()
end

function menu:draw()
  love.graphics.draw(menu_art)
  love.graphics.draw(Buttons.play,Buttons.x,Buttons.Py,0,Buttons.Pxs,Buttons.Pys,Buttons.play:getWidth()/2,Buttons.play:getHeight()/2)
  love.graphics.draw(Buttons.exit,Buttons.x,Buttons.Ey,0,Buttons.Exs,Buttons.Eys,Buttons.exit:getWidth()/2,Buttons.exit:getHeight()/2)
-- love.graphics.print(mouse_x,0,0)
  --love.graphics.print(mouse_y,0,50)
  --love.graphics.print(Buttons.x,0,100)
  --love.graphics.print(Buttons.Py,0,150)
end

return menu